/*
 * Developed By John Saman ePhotoBay.COM
 * contact@ephotobay.com
 */
var ePhotoUploader  = {
    apiURL:'https://www.ephotobay.com/includes/ajax/remotePanel.php?act=',

    onLoad: function() {

        document.getElementById('loginGroupBox').setAttribute("hidden",true);
        document.getElementById('accountGroupBox').setAttribute("hidden",true);
        document.getElementById('failedGroupBox').setAttribute("hidden",true);
        document.getElementById('loadingGroupBox').setAttribute("hidden",false);

        var targetAlbum=document.getElementById('targetAlbum');
        targetAlbum.removeAllItems();

        //load preferences
        var prefs = Components.classes["@mozilla.org/preferences-service;1"]
             .getService(Components.interfaces.nsIPrefService).getBranch("extensions.ePhotoUploader.");

        //set selected action
        document.getElementById('actionAfterUpload').selectedIndex=prefs.getIntPref("actionAfterUpload");

       var xhr = new XMLHttpRequest();

        xhr.open("GET", this.apiURL+"getSelf", true);

        xhr.onload = function (oEvent) {
            if(xhr.responseText!=0){//logged in
                var self=JSON.parse(xhr.responseText);

                var selectedAlbum=prefs.getIntPref("selectedAlbum");

                //load albums list

                targetAlbum.appendItem("No Album","","");
                targetAlbum.selectedIndex=0;//default value

                for(var index in self.albums){
                    var menuitem=document.createElement('menuitem');

                    targetAlbum.appendItem(self.albums[index].title,self.albums[index].id,"");

                    if(selectedAlbum==self.albums[index].id){
                        targetAlbum.selectedIndex=targetAlbum.itemCount-1;
                    }
                }

                document.getElementById('usernameLabel').value="Welcome "+self.username;

                document.getElementById('loadingGroupBox').setAttribute("hidden",true);
                document.getElementById('loginGroupBox').setAttribute("hidden",true);

                document.getElementById('accountGroupBox').setAttribute("hidden",false);

            }else{//logged out
                document.getElementById('usernameLabel').value="";

                document.getElementById('loadingGroupBox').setAttribute("hidden",true);
                document.getElementById('accountGroupBox').setAttribute("hidden",true);

                document.getElementById('loginGroupBox').setAttribute("hidden",false);
            }
        };

        xhr.ontimeout = function(oEvent) {
            document.getElementById('loadingGroupBox').setAttribute("hidden",true);
            document.getElementById('failedGroupBox').setAttribute("hidden",false);
        };
        xhr.send(null);
    },
    signup: function(){
        close();
        var win = Components.classes['@mozilla.org/appshell/window-mediator;1']
        .getService(Components.interfaces.nsIWindowMediator)
        .getMostRecentWindow('navigator:browser');
        
        win.getBrowser().addTab("http://www.ephotobay.com/register.php");
        
    },
    login: function() {
        var xhr = new XMLHttpRequest();

        xhr.open("POST", this.apiURL+"login", true);
                    
        xhr.onload = function (oEvent2) {

            if(xhr.responseText==1){
                ePhotoUploader.onLoad();
            }else{
                alert("Failed to login to ePhotoBay. Username or password is incorrect.");
            }
        };
        var form = new FormData();
        form.append("username",document.getElementById('usernameField').value);
        form.append("password",document.getElementById('passwordField').value);
      
        xhr.send(form);
    },
    logout: function(){
        var xhr = new XMLHttpRequest();

        xhr.open("GET", this.apiURL+"logout", true);

        xhr.onload = function (oEvent2) {
            if(xhr.responseText==1){
                ePhotoUploader.onLoad();
            }else{
                alert("Failed to logout from ePhotoBay. Please check your internet connection.");
            }
        };
      
        xhr.send(null);
    },
    OK: function(){
        var prefService = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService);
        var prefs = prefService.getBranch("extensions.ePhotoUploader.");
        
        prefs.setIntPref("selectedAlbum",document.getElementById('targetAlbum').selectedItem.value);
        prefs.setIntPref("actionAfterUpload",document.getElementById('actionAfterUpload').selectedIndex);
        
        prefService.savePrefFile(null);
        
        close();
    }
};

window.addEventListener("load", function(e) { ePhotoUploader.onLoad(e); }, false); 
