/*
 * Developed By John Saman ePhotoBay.COM
 * contact@ephotobay.com
 */

var ePhotoUploader  = {
    apiURL:'https://www.ephotobay.com/includes/ajax/remotePanel.php?act=',

    onLoad: function() {
        // initialization code
        this.initialized = true;

        var contextMenu = document.getElementById("contentAreaContextMenu");
	if (contextMenu){
            contextMenu.addEventListener("popupshowing", this.showHideItem, false);
	}
    },
    onToolbarButtonCommand: function() {
        window.open("chrome://ePhotoUploader/content/options.xul", "", "chrome,titlebar,toolbar,centerscreen,modal");
    },

    showHideItem:function (){
        var show = document.getElementById("upload-to-ephotobay");
        document.getElementById("upload-to-ephotobay-s").hidden=show.hidden = !(gContextMenu.onImage);
    },
    uploadToEPhotoBay:function (){
        var element = document.popupNode;
        var isImage = (element instanceof Components.interfaces.nsIImageLoadingContent &&
            element.currentURI);
        if(isImage){

            var prefService = Components.classes["@mozilla.org/preferences-service;1"]
            .getService(Components.interfaces.nsIPrefService);
            var prefs = prefService.getBranch("extensions.ePhotoUploader.");

            prefs.getIntPref("selectedAlbum");
     

            //upload by url if accessible
            req = new XMLHttpRequest();

            req.onload=function (evt) {

                if(req.responseText.length>3){//success
                    ePhotoUploader.handleSuccess(prefs,req.responseText);
                }
                else if(req.responseText==-1)//inaccessible so try to download and upload
                {
                    req=null;


                    ePhotoUploader.downloadAndUpload(prefs,element);
                }else{
                    ePhotoUploader.handleError(req.responseText);
                }
            }

            params="u_1="+element.src+"&gid="+prefs.getIntPref("selectedAlbum");
            req.open('POST', this.apiURL+"upload", true);
            req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            req.setRequestHeader("Content-length", params.length);
            req.setRequestHeader("Connection", "close");

            req.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
            req.send(params);
        }
    },
    downloadAndUpload:function (prefs,element){
        // download the image
        var receiver = new XMLHttpRequest();
        var sender = new XMLHttpRequest();
    
        receiver.open('GET',element.src, true);
        receiver.responseType = "arraybuffer";
    
        receiver.onload = function(oEvent) {
        
            sender.open("POST", ePhotoUploader.apiURL+"upload", true);
        
            // sender.setRequestHeader("Content-Type", "multipart/form-data");

            sender.onload = function (oEvent2) {
                // Uploaded.
                if(sender.responseText.length>2){//success
                    ePhotoUploader.handleSuccess(prefs,sender.responseText);
                }
                else{
                    ePhotoUploader.handleError(sender.responseText);
                }
            };
            var form = new FormData();
            form.append("f_0",new Blob([receiver.response], {type: "image/png"}),element.src.substring(element.src.lastIndexOf("/")+1));
            receiver=null;
            form.append("gid",prefs.getIntPref("selectedAlbum"));
            form.append("fn_0",element.src.substring(element.src.lastIndexOf("/")+1))
        
            sender.send(form);
        };
    
        receiver.send(null);
    },
    handleSuccess:function (prefs,responseText){
        switch(prefs.getIntPref("actionAfterUpload")){
            default:
            case 0:
                {
                    //no action
                    break;
                }
            case 1://display confirmation message
                {
                    alert("Image uploaded successfully.");
                    break;
                }
            case 2://open codes
                {
                    var win = Components.classes['@mozilla.org/appshell/window-mediator;1']
                    .getService(Components.interfaces.nsIWindowMediator)
                    .getMostRecentWindow('navigator:browser');
                        
                    win.getBrowser().addTab(responseText);
                    break;
                }
            case 3:
                {
                    var win = Components.classes['@mozilla.org/appshell/window-mediator;1']
                    .getService(Components.interfaces.nsIWindowMediator)
                    .getMostRecentWindow('navigator:browser');
                        
                    win.getBrowser().addTab("http://www.ephotobay.com/my-images.php?id="+prefs.getIntPref("selectedAlbum"));
                    break;
                }
        }
    },
    handleError:function (responseText){
        switch(parseInt(responseText)){
            case 0:
                {
                    alert("Please login first to ePhotoBay to upload images to your account.");
                
                    var win = Components.classes['@mozilla.org/appshell/window-mediator;1']
                    .getService(Components.interfaces.nsIWindowMediator)
                    .getMostRecentWindow('navigator:browser');
                
                    win.getBrowser().addTab("http://www.ephotobay.com/login.php");
                    break;
                }
            case -1://inaccessible
                {
                    alert("This image is not accessible please upload directly from your ePhotoBay account.");

                    break;
                }
            case -2://blocked
                {
                    alert("Your IP is blocked by our system. Probably for infringing our rules. If you think this is in error or for declusion from our black list please contact us.");

                    break;
                }
            case -3://internal error
                {
                    alert("Couldn't upload the image or incorrect file type.");

                    break;
                }
        }
    }   
};
window.addEventListener("load", function(e) { ePhotoUploader.onLoad(e); }, false); 
